/*
 * Java-Modell des Datenkatalogs.
 * Copyright (C) 2016 BitCtrl Systems GmbH 
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weißenfelser Straße 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.sys.funclib.bitctrl.modell.tmnbaglobal.parameter;

import java.util.*;

import com.bitctrl.beans.*;

import de.bsvrz.dav.daf.main.*;
import de.bsvrz.dav.daf.main.config.*;
import de.bsvrz.sys.funclib.bitctrl.modell.*;
import de.bsvrz.sys.funclib.bitctrl.modell.annotation.*;
import de.bsvrz.sys.funclib.bitctrl.modell.att.*;
import de.bsvrz.sys.funclib.bitctrl.modell.impl.*;

/**
Parameter für die Steuerungslogik für die lokale Beeinflussung Ursacheneinheit.
<p>

</p>
* @author BitCtrl Systems GmbH, M2T
 * @version Gültig seit KB-Version 8
 */
public class PdNbaUrsachenEinheit extends AbstractParameterDatensatz<PdNbaUrsachenEinheit.Daten> {

		/**
		 * Die vorhandenen Aspekte des Datensatzes.
		 */
		public static class Aspekte extends de.bsvrz.sys.funclib.bitctrl.modell.metamodellglobal.objekte.impl.AspektImpl implements Aspekt {
	
			public static Aspekt[] values() {
				return new Aspekt[] {
					Aspekte.ParameterDefault,
					Aspekte.ParameterSoll,
					Aspekte.ParameterVorgabe,
					Aspekte.ParameterIst,
				};
			}
	
			/**
			 * Aspekt der zur Versorgung von Defaultwerten für Parameter verwendet werden kann.	 
			 *
			 * <p>
			 * 
	         * </p>
			 */
			public static final Aspekt ParameterDefault = new Aspekte("Default-Parameter-Aspekt", "asp.parameterDefault");
			
			/**
			 * Wird für Parametersätze als Platzhalter verwendet und später durch die Konfiguration automatisch durch die zugesicherten Aspekte von Parametern ersetzt.	 
			 *
			 * <p>
			 * 
	         * </p>
			 */
			public static final Aspekt ParameterSoll = new Aspekte("Soll-Parameter-Aspekt", "asp.parameterSoll");
			
			/**
			 * Wird für Parametersätze als Platzhalter verwendet und später durch die Konfiguration automatisch durch die zugesicherten Aspekte von Parametern ersetzt.	 
			 *
			 * <p>
			 * 
	         * </p>
			 */
			public static final Aspekt ParameterVorgabe = new Aspekte("Vorgabe-Parameter-Aspekt", "asp.parameterVorgabe");
			
			/**
			 * Wird für Parametersätze als Platzhalter verwendet und später durch die Konfiguration automatisch durch die zugesicherten Aspekte von Parametern ersetzt.	 
			 *
			 * <p>
			 * 
	         * </p>
			 */
			public static final Aspekt ParameterIst = new Aspekte("Ist-Parameter-Aspekt", "asp.parameterIst");
			
			;
			
			private final String name;
			private final String pid;
	
			private Aspekte(final String name, final String pid) {
				this.name = name;
				this.pid = pid;
			}
	
			@Override
			public String getName() {
				if (getSystemObject() == null) {
					return name;
				}
				return super.getName();
			}
	
			@Override
			public String getPid() {
				if (getSystemObject() == null) {
					return pid;
				}
				return super.getPid();
			}
			
			@Override
			public Aspect getSystemObject() {
				return (Aspect) super.getSystemObject();
			}
	
			@Override
			public String toString() {
				if (getSystemObject() == null) {
					return name + " (" + pid + ")";
				}
				return super.toString();
			}
	
		}
	
	/**
	 * Kapselt die Daten des Datensatzes.
	 */
	public static class Daten extends AbstractOnlineDatum {
		
		/**
		 * Initialisiert das Onlinedatum.
		 * 
		 * @param datensatz
		 *            der Datensatz zu dem das Datum gehört.
		 * @param aspekt
		 *            der Aspekt für das Datum.
		 */
		public Daten(final Datensatz datensatz, final Aspekt aspekt) {
			super(datensatz, aspekt);
		}
		
		
			/*
			 * Beginn Propertiesabschnitt
			 */
		
				private de.bsvrz.sys.funclib.bitctrl.modell.tmnbaglobal.attribute.AttNbaUeBetriebsart
				 _betriebsart
				;
				private de.bsvrz.sys.funclib.bitctrl.modell.tmnbaglobal.attribute.AtlNbaStrgMindeststandzeit
				 _mindeststandzeit
				= new de.bsvrz.sys.funclib.bitctrl.modell.tmnbaglobal.attribute.AtlNbaStrgMindeststandzeit
				()
				;
				private de.bsvrz.sys.funclib.bitctrl.modell.tmnbaglobal.attribute.AttNbaAbarbeitung
				 _abarbeitung
				;
				private de.bsvrz.sys.funclib.bitctrl.modell.tmnbaglobal.attribute.AttNbaPrioritaet
				 _prioritaet
				;
				private de.bsvrz.sys.funclib.bitctrl.modell.tmvewbetriebglobal.attribute.AtlUrlasser
				 _urlasser
				= new de.bsvrz.sys.funclib.bitctrl.modell.tmvewbetriebglobal.attribute.AtlUrlasser
				()
				;
		
			/**
			Die Ergebnisse der einzelnen Algorithmen werden mit dieser Priorität überlagert.
			<p>
			
			</p>
			
			@return der Wert von Betriebsart.
			*/
				public de.bsvrz.sys.funclib.bitctrl.modell.tmnbaglobal.attribute.AttNbaUeBetriebsart
				 getBetriebsart() {
				return _betriebsart;
			}
		
			/**
			Die Ergebnisse der einzelnen Algorithmen werden mit dieser Priorität überlagert.
			<p>
			
			</p>
			
			@param _betriebsart der neue Wert von Betriebsart.
			*/
			public void setBetriebsart(de.bsvrz.sys.funclib.bitctrl.modell.tmnbaglobal.attribute.AttNbaUeBetriebsart
			 _betriebsart) {
				this._betriebsart = _betriebsart;
			}
		
			/**
			Mindeststandzeit pro Ursacheneinheit.
			<p>
			
			</p>
			
			@return der Wert von Mindeststandzeit.
			*/
				public de.bsvrz.sys.funclib.bitctrl.modell.tmnbaglobal.attribute.AtlNbaStrgMindeststandzeit
				 getMindeststandzeit() {
				return _mindeststandzeit;
			}
		
			/**
			Mindeststandzeit pro Ursacheneinheit.
			<p>
			
			</p>
			
			@param _mindeststandzeit der neue Wert von Mindeststandzeit.
			*/
			public void setMindeststandzeit(de.bsvrz.sys.funclib.bitctrl.modell.tmnbaglobal.attribute.AtlNbaStrgMindeststandzeit
			 _mindeststandzeit) {
				this._mindeststandzeit = _mindeststandzeit;
			}
		
			/**
			Art der Abarbeitung durch die Steuerung.
			<p>
			
			</p>
			
			@return der Wert von Abarbeitung.
			*/
				public de.bsvrz.sys.funclib.bitctrl.modell.tmnbaglobal.attribute.AttNbaAbarbeitung
				 getAbarbeitung() {
				return _abarbeitung;
			}
		
			/**
			Art der Abarbeitung durch die Steuerung.
			<p>
			
			</p>
			
			@param _abarbeitung der neue Wert von Abarbeitung.
			*/
			public void setAbarbeitung(de.bsvrz.sys.funclib.bitctrl.modell.tmnbaglobal.attribute.AttNbaAbarbeitung
			 _abarbeitung) {
				this._abarbeitung = _abarbeitung;
			}
		
			/**
			Priorität.
			<p>
			
			</p>
			
			@return der Wert von Prioritaet.
			*/
				public de.bsvrz.sys.funclib.bitctrl.modell.tmnbaglobal.attribute.AttNbaPrioritaet
				 getPrioritaet() {
				return _prioritaet;
			}
		
			/**
			Priorität.
			<p>
			
			</p>
			
			@param _prioritaet der neue Wert von Prioritaet.
			*/
			public void setPrioritaet(de.bsvrz.sys.funclib.bitctrl.modell.tmnbaglobal.attribute.AttNbaPrioritaet
			 _prioritaet) {
				this._prioritaet = _prioritaet;
			}
		
			/**
			Urlasser Informationen.
			<p>
			
			</p>
			
			@return der Wert von Urlasser.
			*/
				public de.bsvrz.sys.funclib.bitctrl.modell.tmvewbetriebglobal.attribute.AtlUrlasser
				 getUrlasser() {
				return _urlasser;
			}
		
			/**
			Urlasser Informationen.
			<p>
			
			</p>
			
			@param _urlasser der neue Wert von Urlasser.
			*/
			public void setUrlasser(de.bsvrz.sys.funclib.bitctrl.modell.tmvewbetriebglobal.attribute.AtlUrlasser
			 _urlasser) {
				this._urlasser = _urlasser;
			}
		
		
			/*
			 * Ende Propertiesabschnitt
			 */
		
			/*
			 * Beginn Abschnitt Konvertierung Datenverteiler <-> Modell
			 */
		
			public void bean2Atl(final Data datum, final ObjektFactory factory) {
					// GanzzahlAttributTyp
					if (getBetriebsart() != null) {
		                if (getBetriebsart().isZustand()) {
		                    datum.getUnscaledValue("Betriebsart").setText(getBetriebsart().toString());
		                } else {
							datum.
							getUnscaledValue
		                	("Betriebsart").set(getBetriebsart().getValue());
		                }
					}
					// AttributListenDefinition
						getMindeststandzeit().bean2Atl(datum.getItem("Mindeststandzeit"), factory);
					// GanzzahlAttributTyp
					if (getAbarbeitung() != null) {
		                if (getAbarbeitung().isZustand()) {
		                    datum.getUnscaledValue("Abarbeitung").setText(getAbarbeitung().toString());
		                } else {
							datum.
							getUnscaledValue
		                	("Abarbeitung").set(getAbarbeitung().getValue());
		                }
					}
					// GanzzahlAttributTyp
					if (getPrioritaet() != null) {
		                if (getPrioritaet().isZustand()) {
		                    datum.getUnscaledValue("Priorität").setText(getPrioritaet().toString());
		                } else {
							datum.
							getUnscaledValue
		                	("Priorität").set(getPrioritaet().getValue());
		                }
					}
					// AttributListenDefinition
						getUrlasser().bean2Atl(datum.getItem("Urlasser"), factory);
			}
		
			public void atl2Bean(final Data daten, final ObjektFactory factory) {
					// GanzzahlAttributTyp
							if (daten.getUnscaledValue("Betriebsart").isState()) {
								setBetriebsart(de.bsvrz.sys.funclib.bitctrl.modell.tmnbaglobal.attribute.AttNbaUeBetriebsart
								.getZustand(daten.getScaledValue("Betriebsart").getText()));
							} else {
							setBetriebsart(new de.bsvrz.sys.funclib.bitctrl.modell.tmnbaglobal.attribute.AttNbaUeBetriebsart
							(daten.
								getUnscaledValue
							("Betriebsart").
									byteValue
							()));
							}
					// AttributListenDefinition
						getMindeststandzeit().atl2Bean(daten.getItem("Mindeststandzeit"), factory);
					// GanzzahlAttributTyp
							if (daten.getUnscaledValue("Abarbeitung").isState()) {
								setAbarbeitung(de.bsvrz.sys.funclib.bitctrl.modell.tmnbaglobal.attribute.AttNbaAbarbeitung
								.getZustand(daten.getScaledValue("Abarbeitung").getText()));
							} else {
							setAbarbeitung(new de.bsvrz.sys.funclib.bitctrl.modell.tmnbaglobal.attribute.AttNbaAbarbeitung
							(daten.
								getUnscaledValue
							("Abarbeitung").
									byteValue
							()));
							}
					// GanzzahlAttributTyp
							if (daten.getUnscaledValue("Priorität").isState()) {
								setPrioritaet(de.bsvrz.sys.funclib.bitctrl.modell.tmnbaglobal.attribute.AttNbaPrioritaet
								.getZustand(daten.getScaledValue("Priorität").getText()));
							} else {
							setPrioritaet(new de.bsvrz.sys.funclib.bitctrl.modell.tmnbaglobal.attribute.AttNbaPrioritaet
							(daten.
								getUnscaledValue
							("Priorität").
									intValue
							()));
							}
					// AttributListenDefinition
						getUrlasser().atl2Bean(daten.getItem("Urlasser"), factory);
			}
		
			/*
			 * Ende Abschnitt Konvertierung Datenverteiler <-> Modell
			 */
		
			
		@Override
		public Daten clone() {
			final Daten klon = new Daten(dGetDatensatz(), dGetAspekt());
	
							klon.setBetriebsart(getBetriebsart());
							klon._mindeststandzeit = getMindeststandzeit().clone();
							klon.setAbarbeitung(getAbarbeitung());
							klon.setPrioritaet(getPrioritaet());
							klon._urlasser = getUrlasser().clone();
			
			
			klon.dSetZeitstempel(dGetZeitstempel());
			klon.dSetDatenStatus(dGetDatenStatus());
	
			return klon;
		}

		@Override
		public String toString() {
			return BeanUtils.toString(this);
		}
	
	}

		/** Die PID der Attributgruppe im Datenverteiler. */
		public static final String PID = "atg.nbaUrsachenEinheit";

	/**
	 * Initialisiert den Parameterdatensatz.
	 * 
	 * @param systemObjekt
	 *            das Systemobjekt zu dem der Datensatz gehört.
	 * @param objektFactory
	 *            die ObjektFabrik, die der Datensatz verwenden soll.
	 */
	public PdNbaUrsachenEinheit(final SystemObjekt systemObjekt,
			final ObjektFactory objektFactory) {
		super(systemObjekt, objektFactory);
	}

	
		@Override
		public void init(final SystemObject systemObject,
				final ObjektFactory objektFactory) {
			super.init(systemObject, objektFactory);
			for (final Aspekt asp : Aspekte.values()) {
				((AbstractSystemObjekt) asp).init(objektFactory.getModellobjekt(asp.getPid()).getSystemObject(), objektFactory);
			}
		}
		
		@Override
		protected String doGetPid() {
			return PID;
		}
	
		public Collection<? extends Aspekt> getAspekte() {
			return Arrays.asList(Aspekte.values());
		}
	
		public Daten createDatum() {
			Daten datum = new Daten(this, null);
			// TODO Auslesen der Defaultwerte geht nicht,
			// weil der Datenverteiler für Attribute ohne Defaultwert initial ungültige Werte setzt!!
			// datum.atl2Bean(createSendeCache(), getObjektFactory());
			return datum;
		}
		 

}
