/*
 * Java-Modell des Datenkatalogs.
 * Copyright (C) 2016 BitCtrl Systems GmbH 
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weißenfelser Straße 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.sys.funclib.bitctrl.modell.tmumfelddatenglobal.parameter;

import java.util.*;

import com.bitctrl.beans.*;

import de.bsvrz.dav.daf.main.*;
import de.bsvrz.dav.daf.main.config.*;
import de.bsvrz.sys.funclib.bitctrl.modell.*;
import de.bsvrz.sys.funclib.bitctrl.modell.annotation.*;
import de.bsvrz.sys.funclib.bitctrl.modell.att.*;
import de.bsvrz.sys.funclib.bitctrl.modell.impl.*;

/**
Parameter für die Grenzwertprüfung der TaupunktTemperatur.
<p>

</p>
* @author BitCtrl Systems GmbH, M2T
 * @version Gültig seit KB-Version 25
 */
public class PdUfdsGrenzwerteTaupunktTemperatur extends AbstractParameterDatensatz<PdUfdsGrenzwerteTaupunktTemperatur.Daten> {

		/**
		 * Die vorhandenen Aspekte des Datensatzes.
		 */
		public static class Aspekte extends de.bsvrz.sys.funclib.bitctrl.modell.metamodellglobal.objekte.impl.AspektImpl implements Aspekt {
	
			public static Aspekt[] values() {
				return new Aspekt[] {
					Aspekte.ParameterDefault,
					Aspekte.ParameterSoll,
					Aspekte.ParameterVorgabe,
					Aspekte.ParameterIst,
				};
			}
	
			/**
			 * Aspekt der zur Versorgung von Defaultwerten für Parameter verwendet werden kann.	 
			 *
			 * <p>
			 * 
	         * </p>
			 */
			public static final Aspekt ParameterDefault = new Aspekte("Default-Parameter-Aspekt", "asp.parameterDefault");
			
			/**
			 * Wird für Parametersätze als Platzhalter verwendet und später durch die Konfiguration automatisch durch die zugesicherten Aspekte von Parametern ersetzt.	 
			 *
			 * <p>
			 * 
	         * </p>
			 */
			public static final Aspekt ParameterSoll = new Aspekte("Soll-Parameter-Aspekt", "asp.parameterSoll");
			
			/**
			 * Wird für Parametersätze als Platzhalter verwendet und später durch die Konfiguration automatisch durch die zugesicherten Aspekte von Parametern ersetzt.	 
			 *
			 * <p>
			 * 
	         * </p>
			 */
			public static final Aspekt ParameterVorgabe = new Aspekte("Vorgabe-Parameter-Aspekt", "asp.parameterVorgabe");
			
			/**
			 * Wird für Parametersätze als Platzhalter verwendet und später durch die Konfiguration automatisch durch die zugesicherten Aspekte von Parametern ersetzt.	 
			 *
			 * <p>
			 * 
	         * </p>
			 */
			public static final Aspekt ParameterIst = new Aspekte("Ist-Parameter-Aspekt", "asp.parameterIst");
			
			;
			
			private final String name;
			private final String pid;
	
			private Aspekte(final String name, final String pid) {
				this.name = name;
				this.pid = pid;
			}
	
			@Override
			public String getName() {
				if (getSystemObject() == null) {
					return name;
				}
				return super.getName();
			}
	
			@Override
			public String getPid() {
				if (getSystemObject() == null) {
					return pid;
				}
				return super.getPid();
			}
			
			@Override
			public Aspect getSystemObject() {
				return (Aspect) super.getSystemObject();
			}
	
			@Override
			public String toString() {
				if (getSystemObject() == null) {
					return name + " (" + pid + ")";
				}
				return super.toString();
			}
	
		}
	
	/**
	 * Kapselt die Daten des Datensatzes.
	 */
	public static class Daten extends AbstractOnlineDatum {
		
		/**
		 * Initialisiert das Onlinedatum.
		 * 
		 * @param datensatz
		 *            der Datensatz zu dem das Datum gehört.
		 * @param aspekt
		 *            der Aspekt für das Datum.
		 */
		public Daten(final Datensatz datensatz, final Aspekt aspekt) {
			super(datensatz, aspekt);
		}
		
		
			/*
			 * Beginn Propertiesabschnitt
			 */
		
				private de.bsvrz.sys.funclib.bitctrl.modell.tmvewbetriebglobal.attribute.AtlUrlasser
				 _urlasser
				= new de.bsvrz.sys.funclib.bitctrl.modell.tmvewbetriebglobal.attribute.AtlUrlasser
				()
				;
				private de.bsvrz.sys.funclib.bitctrl.modell.tmumfelddatenglobal.attribute.AttVerhaltenGrenzwertPruefungUFD
				 _verhalten
				;
				private de.bsvrz.sys.funclib.bitctrl.modell.tmumfelddatenglobal.attribute.AttUfdsTaupunktTemperatur
				 _tPTmin
				;
				private de.bsvrz.sys.funclib.bitctrl.modell.tmumfelddatenglobal.attribute.AttUfdsTaupunktTemperatur
				 _tPTmax
				;
		
			/**
			Urlasserinformationen.
			<p>
			Urlasserinformationen bestehen aus einer Referenz auf den Benutzer, der die Meldung erzeugt hat, einer Angabe der Ursache für die Meldung und einem Veranlasser für die Meldung.
			</p>
			
			@return der Wert von Urlasser.
			*/
				public de.bsvrz.sys.funclib.bitctrl.modell.tmvewbetriebglobal.attribute.AtlUrlasser
				 getUrlasser() {
				return _urlasser;
			}
		
			/**
			Urlasserinformationen.
			<p>
			Urlasserinformationen bestehen aus einer Referenz auf den Benutzer, der die Meldung erzeugt hat, einer Angabe der Ursache für die Meldung und einem Veranlasser für die Meldung.
			</p>
			
			@param _urlasser der neue Wert von Urlasser.
			*/
			public void setUrlasser(de.bsvrz.sys.funclib.bitctrl.modell.tmvewbetriebglobal.attribute.AtlUrlasser
			 _urlasser) {
				this._urlasser = _urlasser;
			}
		
			/**
			Definiert das Verhalten der Grenzwertprüfung bei Überschreitung des Grenzwerts.
			<p>
			
			</p>
			
			@return der Wert von Verhalten.
			*/
				public de.bsvrz.sys.funclib.bitctrl.modell.tmumfelddatenglobal.attribute.AttVerhaltenGrenzwertPruefungUFD
				 getVerhalten() {
				return _verhalten;
			}
		
			/**
			Definiert das Verhalten der Grenzwertprüfung bei Überschreitung des Grenzwerts.
			<p>
			
			</p>
			
			@param _verhalten der neue Wert von Verhalten.
			*/
			public void setVerhalten(de.bsvrz.sys.funclib.bitctrl.modell.tmumfelddatenglobal.attribute.AttVerhaltenGrenzwertPruefungUFD
			 _verhalten) {
				this._verhalten = _verhalten;
			}
		
			/**
			Taupunkttemperatur.
			<p>
			Taupunkttemperatur ist diejenige Temperatur, bei der die in der Umgebungsluft der Messstelle (am Ort der Temperatur und Feuchte-Sensorik) befindliche Feuchte zu kondensieren beginnt. Die Taupunkttemperatur ist aus der Temperatur und der relativen Feuchte der Luft zu bestimmen. Zur Bestimmung ist die in den neuesten ?betriebstechnischen Anforderungen für Glättemeldeanlagen? enthaltene Berechnungsvorschrift zu verwenden. Dieser Berechnungsvorschrift liegen auch die im Wetterdienst verwendeten Taupunkttabellen zugrunde.
			</p>
			
			@return der Wert von TPTmin.
			*/
				public de.bsvrz.sys.funclib.bitctrl.modell.tmumfelddatenglobal.attribute.AttUfdsTaupunktTemperatur
				 getTPTmin() {
				return _tPTmin;
			}
		
			/**
			Taupunkttemperatur.
			<p>
			Taupunkttemperatur ist diejenige Temperatur, bei der die in der Umgebungsluft der Messstelle (am Ort der Temperatur und Feuchte-Sensorik) befindliche Feuchte zu kondensieren beginnt. Die Taupunkttemperatur ist aus der Temperatur und der relativen Feuchte der Luft zu bestimmen. Zur Bestimmung ist die in den neuesten ?betriebstechnischen Anforderungen für Glättemeldeanlagen? enthaltene Berechnungsvorschrift zu verwenden. Dieser Berechnungsvorschrift liegen auch die im Wetterdienst verwendeten Taupunkttabellen zugrunde.
			</p>
			
			@param _tPTmin der neue Wert von TPTmin.
			*/
			public void setTPTmin(de.bsvrz.sys.funclib.bitctrl.modell.tmumfelddatenglobal.attribute.AttUfdsTaupunktTemperatur
			 _tPTmin) {
				this._tPTmin = _tPTmin;
			}
		
			/**
			Taupunkttemperatur.
			<p>
			Taupunkttemperatur ist diejenige Temperatur, bei der die in der Umgebungsluft der Messstelle (am Ort der Temperatur und Feuchte-Sensorik) befindliche Feuchte zu kondensieren beginnt. Die Taupunkttemperatur ist aus der Temperatur und der relativen Feuchte der Luft zu bestimmen. Zur Bestimmung ist die in den neuesten ?betriebstechnischen Anforderungen für Glättemeldeanlagen? enthaltene Berechnungsvorschrift zu verwenden. Dieser Berechnungsvorschrift liegen auch die im Wetterdienst verwendeten Taupunkttabellen zugrunde.
			</p>
			
			@return der Wert von TPTmax.
			*/
				public de.bsvrz.sys.funclib.bitctrl.modell.tmumfelddatenglobal.attribute.AttUfdsTaupunktTemperatur
				 getTPTmax() {
				return _tPTmax;
			}
		
			/**
			Taupunkttemperatur.
			<p>
			Taupunkttemperatur ist diejenige Temperatur, bei der die in der Umgebungsluft der Messstelle (am Ort der Temperatur und Feuchte-Sensorik) befindliche Feuchte zu kondensieren beginnt. Die Taupunkttemperatur ist aus der Temperatur und der relativen Feuchte der Luft zu bestimmen. Zur Bestimmung ist die in den neuesten ?betriebstechnischen Anforderungen für Glättemeldeanlagen? enthaltene Berechnungsvorschrift zu verwenden. Dieser Berechnungsvorschrift liegen auch die im Wetterdienst verwendeten Taupunkttabellen zugrunde.
			</p>
			
			@param _tPTmax der neue Wert von TPTmax.
			*/
			public void setTPTmax(de.bsvrz.sys.funclib.bitctrl.modell.tmumfelddatenglobal.attribute.AttUfdsTaupunktTemperatur
			 _tPTmax) {
				this._tPTmax = _tPTmax;
			}
		
		
			/*
			 * Ende Propertiesabschnitt
			 */
		
			/*
			 * Beginn Abschnitt Konvertierung Datenverteiler <-> Modell
			 */
		
			public void bean2Atl(final Data datum, final ObjektFactory factory) {
					// AttributListenDefinition
						getUrlasser().bean2Atl(datum.getItem("Urlasser"), factory);
					// GanzzahlAttributTyp
					if (getVerhalten() != null) {
		                if (getVerhalten().isZustand()) {
		                    datum.getUnscaledValue("Verhalten").setText(getVerhalten().toString());
		                } else {
							datum.
							getUnscaledValue
		                	("Verhalten").set(getVerhalten().getValue());
		                }
					}
					// GanzzahlAttributTyp
					if (getTPTmin() != null) {
		                if (getTPTmin().isZustand()) {
		                    datum.getUnscaledValue("TPTmin").setText(getTPTmin().toString());
		                } else {
							datum.
							getScaledValue
		                	("TPTmin").set(getTPTmin().getValue());
		                }
					}
					// GanzzahlAttributTyp
					if (getTPTmax() != null) {
		                if (getTPTmax().isZustand()) {
		                    datum.getUnscaledValue("TPTmax").setText(getTPTmax().toString());
		                } else {
							datum.
							getScaledValue
		                	("TPTmax").set(getTPTmax().getValue());
		                }
					}
			}
		
			public void atl2Bean(final Data daten, final ObjektFactory factory) {
					// AttributListenDefinition
						getUrlasser().atl2Bean(daten.getItem("Urlasser"), factory);
					// GanzzahlAttributTyp
							if (daten.getUnscaledValue("Verhalten").isState()) {
								setVerhalten(de.bsvrz.sys.funclib.bitctrl.modell.tmumfelddatenglobal.attribute.AttVerhaltenGrenzwertPruefungUFD
								.getZustand(daten.getScaledValue("Verhalten").getText()));
							} else {
							setVerhalten(new de.bsvrz.sys.funclib.bitctrl.modell.tmumfelddatenglobal.attribute.AttVerhaltenGrenzwertPruefungUFD
							(daten.
								getUnscaledValue
							("Verhalten").
									byteValue
							()));
							}
					// GanzzahlAttributTyp
							if (daten.getUnscaledValue("TPTmin").isState()) {
								setTPTmin(de.bsvrz.sys.funclib.bitctrl.modell.tmumfelddatenglobal.attribute.AttUfdsTaupunktTemperatur
								.getZustand(daten.getScaledValue("TPTmin").getText()));
							} else {
							setTPTmin(new de.bsvrz.sys.funclib.bitctrl.modell.tmumfelddatenglobal.attribute.AttUfdsTaupunktTemperatur
							(daten.
								getScaledValue
							("TPTmin").
								doubleValue
							()));
							}
					// GanzzahlAttributTyp
							if (daten.getUnscaledValue("TPTmax").isState()) {
								setTPTmax(de.bsvrz.sys.funclib.bitctrl.modell.tmumfelddatenglobal.attribute.AttUfdsTaupunktTemperatur
								.getZustand(daten.getScaledValue("TPTmax").getText()));
							} else {
							setTPTmax(new de.bsvrz.sys.funclib.bitctrl.modell.tmumfelddatenglobal.attribute.AttUfdsTaupunktTemperatur
							(daten.
								getScaledValue
							("TPTmax").
								doubleValue
							()));
							}
			}
		
			/*
			 * Ende Abschnitt Konvertierung Datenverteiler <-> Modell
			 */
		
			
		@Override
		public Daten clone() {
			final Daten klon = new Daten(dGetDatensatz(), dGetAspekt());
	
							klon._urlasser = getUrlasser().clone();
							klon.setVerhalten(getVerhalten());
							klon.setTPTmin(getTPTmin());
							klon.setTPTmax(getTPTmax());
			
			
			klon.dSetZeitstempel(dGetZeitstempel());
			klon.dSetDatenStatus(dGetDatenStatus());
	
			return klon;
		}

		@Override
		public String toString() {
			return BeanUtils.toString(this);
		}
	
	}

		/** Die PID der Attributgruppe im Datenverteiler. */
		public static final String PID = "atg.ufdsGrenzwerteTaupunktTemperatur";

	/**
	 * Initialisiert den Parameterdatensatz.
	 * 
	 * @param systemObjekt
	 *            das Systemobjekt zu dem der Datensatz gehört.
	 * @param objektFactory
	 *            die ObjektFabrik, die der Datensatz verwenden soll.
	 */
	public PdUfdsGrenzwerteTaupunktTemperatur(final SystemObjekt systemObjekt,
			final ObjektFactory objektFactory) {
		super(systemObjekt, objektFactory);
	}

	
		@Override
		public void init(final SystemObject systemObject,
				final ObjektFactory objektFactory) {
			super.init(systemObject, objektFactory);
			for (final Aspekt asp : Aspekte.values()) {
				((AbstractSystemObjekt) asp).init(objektFactory.getModellobjekt(asp.getPid()).getSystemObject(), objektFactory);
			}
		}
		
		@Override
		protected String doGetPid() {
			return PID;
		}
	
		public Collection<? extends Aspekt> getAspekte() {
			return Arrays.asList(Aspekte.values());
		}
	
		public Daten createDatum() {
			Daten datum = new Daten(this, null);
			// TODO Auslesen der Defaultwerte geht nicht,
			// weil der Datenverteiler für Attribute ohne Defaultwert initial ungültige Werte setzt!!
			// datum.atl2Bean(createSendeCache(), getObjektFactory());
			return datum;
		}
		 

}
