/*
 * Java-Modell des Datenkatalogs.
 * Copyright (C) 2016 BitCtrl Systems GmbH 
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weißenfelser Straße 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.konfigurationsdaten;

import java.util.*;

import com.bitctrl.beans.*;

import de.bsvrz.dav.daf.main.*;
import de.bsvrz.dav.daf.main.config.*;
import de.bsvrz.sys.funclib.bitctrl.modell.*;
import de.bsvrz.sys.funclib.bitctrl.modell.annotation.*;
import de.bsvrz.sys.funclib.bitctrl.modell.att.*;
import de.bsvrz.sys.funclib.bitctrl.modell.impl.*;

/**
Konfigurierende Eigenschaften der Objekte des Typs.
<p>

</p>
* @author BitCtrl Systems GmbH, M2T
 * @version Gültig seit KB-Version 10
 */
public class KdAchsLastMessStelle extends AbstractKonfigurationsDatensatz<KdAchsLastMessStelle.Daten> {

		/**
		 * Die vorhandenen Aspekte des Datensatzes.
		 */
		public static class Aspekte extends de.bsvrz.sys.funclib.bitctrl.modell.metamodellglobal.objekte.impl.AspektImpl implements Aspekt {
	
			public static Aspekt[] values() {
				return new Aspekt[] {
					Aspekte.Eigenschaften,
				};
			}
	
			/**
			 * Wird für konfigurierende Attributgruppen verwendet. Über die entsprechende Attributgruppe werden die konkreten Eigenschaften eines Objekts festgelegt.	 
			 *
			 * <p>
			 * 
	         * </p>
			 */
			public static final Aspekt Eigenschaften = new Aspekte("Eigenschaften", "asp.eigenschaften");
			
			;
			
			private final String name;
			private final String pid;
	
			private Aspekte(final String name, final String pid) {
				this.name = name;
				this.pid = pid;
			}
	
			@Override
			public String getName() {
				if (getSystemObject() == null) {
					return name;
				}
				return super.getName();
			}
	
			@Override
			public String getPid() {
				if (getSystemObject() == null) {
					return pid;
				}
				return super.getPid();
			}
			
			@Override
			public Aspect getSystemObject() {
				return (Aspect) super.getSystemObject();
			}
	
			@Override
			public String toString() {
				if (getSystemObject() == null) {
					return name + " (" + pid + ")";
				}
				return super.toString();
			}
	
		}
	
	/**
	 * Kapselt die Daten des Datensatzes.
	 */
	public static class Daten extends AbstractDatum implements KonfigurationsDatum {
		
		/**
		 * Initialisiert das Datum.
		 * 
		 * @param datensatz
		 *            der Datensatz zu dem das Datum gehört.
		 * @param aspekt
		 *            der Aspekt für das Datum.
		 */
		public Daten(final Datensatz datensatz, final Aspekt aspekt) {
			super(datensatz, aspekt);
		}
		
		
			/*
			 * Beginn Propertiesabschnitt
			 */
		
				private 	Object
				 _achsLastMessStellenQuelle
				;
				private 	de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.FahrStreifen
				 _fahrStreifen
				;
		
			/**
			Referenz auf das Objekt, welches die Daten für
									diese Achslastmessstelle liefert (z. B. AXL-DE
									gemäß TLS).
			<p>
			
			</p>
			
			@return der Wert von AchsLastMessStellenQuelle.
			*/
				public 	Object
				 getAchsLastMessStellenQuelle() {
				return _achsLastMessStellenQuelle;
			}
		
			/**
			Referenz auf das Objekt, welches die Daten für
									diese Achslastmessstelle liefert (z. B. AXL-DE
									gemäß TLS).
			<p>
			
			</p>
			
			@param _achsLastMessStellenQuelle der neue Wert von AchsLastMessStellenQuelle.
			*/
			public void setAchsLastMessStellenQuelle(	Object
			 _achsLastMessStellenQuelle) {
				this._achsLastMessStellenQuelle = _achsLastMessStellenQuelle;
			}
		
			/**
			Zugeordnete Fahrstreifenwerte dieser
									Achslastmessstelle.
			<p>
			
			</p>
			
			@return der Wert von FahrStreifen.
			*/
				public 	de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.FahrStreifen
				 getFahrStreifen() {
				return _fahrStreifen;
			}
		
			/**
			Zugeordnete Fahrstreifenwerte dieser
									Achslastmessstelle.
			<p>
			
			</p>
			
			@param _fahrStreifen der neue Wert von FahrStreifen.
			*/
			public void setFahrStreifen(	de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.FahrStreifen
			 _fahrStreifen) {
				this._fahrStreifen = _fahrStreifen;
			}
		
		
			/*
			 * Ende Propertiesabschnitt
			 */
		
			/*
			 * Beginn Abschnitt Konvertierung Datenverteiler <-> Modell
			 */
		
			public void bean2Atl(final Data datum, final ObjektFactory factory) {
					// ObjektReferenzAttributTyp
						final Object soAchsLastMessStellenQuelle = getAchsLastMessStellenQuelle();
						final SystemObject tmpAchsLastMessStellenQuelle;
							if (soAchsLastMessStellenQuelle instanceof SystemObject) {
								tmpAchsLastMessStellenQuelle = (SystemObject)soAchsLastMessStellenQuelle;
							} else if(soAchsLastMessStellenQuelle instanceof SystemObjekt){
								tmpAchsLastMessStellenQuelle = ((SystemObjekt)soAchsLastMessStellenQuelle).getSystemObject();
							} else{
								tmpAchsLastMessStellenQuelle = null;
							}
						datum.getReferenceValue("AchsLastMessStellenQuelle").setSystemObject(tmpAchsLastMessStellenQuelle);
					// ObjektReferenzAttributTyp
						final Object soFahrStreifen = getFahrStreifen();
						final SystemObject tmpFahrStreifen;
							if (soFahrStreifen instanceof SystemObject) {
								tmpFahrStreifen = (SystemObject)soFahrStreifen;
							} else if(soFahrStreifen instanceof SystemObjekt){
								tmpFahrStreifen = ((SystemObjekt)soFahrStreifen).getSystemObject();
							} else{
								tmpFahrStreifen = null;
							}
						datum.getReferenceValue("FahrStreifen").setSystemObject(tmpFahrStreifen);
			}
		
			public void atl2Bean(final Data daten, final ObjektFactory factory) {
					// ObjektReferenzAttributTyp
						final long idAchsLastMessStellenQuelle = daten.getReferenceValue("AchsLastMessStellenQuelle").getId();
						final SystemObjekt tmpAchsLastMessStellenQuelle;
						if (idAchsLastMessStellenQuelle == 0) {
							tmpAchsLastMessStellenQuelle = null;
						} else {
							final SystemObject soAchsLastMessStellenQuelle = factory.getDav().getDataModel().getObject(idAchsLastMessStellenQuelle);
							if (soAchsLastMessStellenQuelle == null) {
									tmpAchsLastMessStellenQuelle = new BaseUngueltigesSystemObjekt(idAchsLastMessStellenQuelle);
							} else {
								tmpAchsLastMessStellenQuelle = factory.getModellobjekt(soAchsLastMessStellenQuelle);
							}
						}
						setAchsLastMessStellenQuelle((	Object
						) tmpAchsLastMessStellenQuelle);
					// ObjektReferenzAttributTyp
						final long idFahrStreifen = daten.getReferenceValue("FahrStreifen").getId();
						final SystemObjekt tmpFahrStreifen;
						if (idFahrStreifen == 0) {
							tmpFahrStreifen = null;
						} else {
							final SystemObject soFahrStreifen = factory.getDav().getDataModel().getObject(idFahrStreifen);
							if (soFahrStreifen == null) {
									tmpFahrStreifen = new de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.impl.FahrStreifenUngueltig(idFahrStreifen);
							} else {
								tmpFahrStreifen = factory.getModellobjekt(soFahrStreifen);
							}
						}
						setFahrStreifen((	de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.FahrStreifen
						) tmpFahrStreifen);
			}
		
			/*
			 * Ende Abschnitt Konvertierung Datenverteiler <-> Modell
			 */
		
			
		@Override
		public Daten clone() {
			final Daten klon = new Daten(dGetDatensatz(), dGetAspekt());
	
							klon.setAchsLastMessStellenQuelle(getAchsLastMessStellenQuelle());
							klon.setFahrStreifen(getFahrStreifen());
			
	
			return klon;
		}

		@Override
		public String toString() {
			return BeanUtils.toString(this);
		}
	
	}
	
		/** Die PID der Attributgruppe im Datenverteiler. */
		public static final String PID = "atg.achsLastMessStelle";

	/**
	 * Initialisiert den Konfigurationsdatensatz.
	 * 
	 * @param systemObjekt
	 *            das Systemobjekt zu dem der Datensatz gehört.
	 * @param objektFactory
	 *            die ObjektFabrik, die der Datensatz verwenden soll.
	 */
	public KdAchsLastMessStelle(final SystemObjekt systemObjekt,
			final ObjektFactory objektFactory) {
		super(systemObjekt, objektFactory);
	}

	
		@Override
		public void init(final SystemObject systemObject,
				final ObjektFactory objektFactory) {
			super.init(systemObject, objektFactory);
			for (final Aspekt asp : Aspekte.values()) {
				((AbstractSystemObjekt) asp).init(objektFactory.getModellobjekt(asp.getPid()).getSystemObject(), objektFactory);
			}
		}
		
		@Override
		protected String doGetPid() {
			return PID;
		}
	
		public Collection<? extends Aspekt> getAspekte() {
			return Arrays.asList(Aspekte.values());
		}
	
		public Daten createDatum() {
			Daten datum = new Daten(this, null);
			// TODO Auslesen der Defaultwerte geht nicht,
			// weil der Datenverteiler für Attribute ohne Defaultwert initial ungültige Werte setzt!!
			// datum.atl2Bean(createSendeCache(), getObjektFactory());
			return datum;
		}
		 
	
}
