/*
 * Java-Modell des Datenkatalogs.
 * Copyright (C) 2016 BitCtrl Systems GmbH 
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weißenfelser Straße 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

/**
Teilmodell mit Datenmodellierung zu den Ganglinien.
<p>
&lt;sektion&gt;
				&lt;titel&gt;Ganglinien&lt;&#47;titel&gt;
				&lt;absatz&gt;
					Die folgende Abbildung skizziert die Zusammenhänge für das automatische Lernen von Ganglinien
					und für die Ganglinienprognose.
				&lt;&#47;absatz&gt;
				&lt;abbildung pid="abb.ganglinienSystem" src="abbildungen&#47;systemereignisganglinien-tmGanglinieSystem.jpg"&gt;
					&lt;titel&gt;Übersicht Ganglinien&lt;&#47;titel&gt;
				&lt;&#47;abbildung&gt;
				&lt;absatz&gt;
					Das Automatische Lernen von Ganglinien erzeugt auf Basis gemessener Verkehrswerte
					historische Ganglinien durch Verschmelzung. Dabei werden aktuell anliegende Ereignisse
					berücksichtigt.
				&lt;&#47;absatz&gt;
				&lt;absatz&gt;
					Die aktuellen Ganglinien werden von der Parametrierung persistent gehalten. Darüber hinaus können
					die Ganglinien im Archivsystem archiviert werden.
				&lt;&#47;absatz&gt;
				&lt;absatz&gt;
					Die erzeugten Ganglinien sind die Grundlage der Ganglinienprognose.
					Der Lernvorgang wird zyklisch in einem parametrierbaren Intervall (z.B. täglich)
					durchgeführt. Um dem Anwender die Möglichkeit zu geben, nachträglich die Daten
					im Ereigniskalender zu vervollständigen, werden nur Analysewerte betrachtet,
					die ein parametrierbares Mindestalter haben (z.B. eine Woche).
				&lt;&#47;absatz&gt;
				&lt;absatz&gt;
					Die folgende Abbildung skizziert die Attributgruppen, die bei der Modellierung von Ganglinien
					und Prognoseganglinien zum Einsatz kommen.
				&lt;&#47;absatz&gt;
				&lt;abbildung pid="abb.ganglinien" src="abbildungen&#47;systemereignisganglinien-atgGanglinien.jpg"&gt;
					&lt;titel&gt;Übersicht Attributgruppen Ganglinien&lt;&#47;titel&gt;
				&lt;&#47;abbildung&gt;
			&lt;&#47;sektion&gt;
</p>
* @author BitCtrl Systems GmbH, M2T
 * @version KB-Version 11
 */
package de.bsvrz.sys.funclib.bitctrl.modell.tmganglinienglobal;
