/*
 * Java-Modell des Datenkatalogs.
 * Copyright (C) 2016 BitCtrl Systems GmbH 
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weißenfelser Straße 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

/**
Teilmodell mit Datenmodellierung zum Datenaustausch von
			TIC3-Verkehrsmeldungen mit der
			Landesmeldestelle (LMS).
<p>
&lt;absatz&gt;Mit den Landesmeldestellen werden die Daten für den
				automatisierten Verkehrswarndienst (RDS&#47;TMC) ausgetauscht.
				Automatisch durch die VRZ erzeugte Meldungen werden an die LMS
				geschickt und von dieser gegebenenfalls modifiziert und
				weitergeleitet.
			&lt;&#47;absatz&gt;
			&lt;absatz&gt;Weiterhin erhält die VRZ von der LMS alle dort vorliegenden
				autorisierten Verkehrswarndienstmeldungen, die auch an Management-
				und Servicepartner zur Verbreitung (an die Verkehrsteilnehmer)
				weitergeleitet werden. Dazu wickelt diese Funktionseinheit die
				komplette Kommunikation mit der Landesmeldestelle ab.
			&lt;&#47;absatz&gt;
			&lt;absatz&gt;Der Austausch erfolgt in Form von XML-Dateien, die mittels
				FTP über TCP&#47;IP übertragen werden. Es werden in beiden Richtungen
				Meldungen nach TIC Info Specification ausgetauscht, wobei mehrere
				Meldungen in einer Datei zusammengefasst werden können.
			&lt;&#47;absatz&gt;
			&lt;absatz&gt;Die Funktion übernimmt die von der Landesmeldestelle
				verschickten Dateien und publiziert sie nach Konvertierung in das
				systeminterne Datenformat. Alle in der Landesmeldestelle
				auflaufenden Meldungen (auch die von der VRZ verschickten) werden
				übertragen.
			&lt;&#47;absatz&gt;
			&lt;absatz&gt;Ein Verbindungsausfall wird von der LMS nicht erkannt. Die
				Meldungen haben nur eine begrenzte Gültigkeitsdauer und müssen bei
				Bedarf wiederholt werden. Dazu wird der Versand der noch anstehenden
				Meldungen an die LMS vor Ablauf der Gültigkeit wiederholt.
			&lt;&#47;absatz&gt;
			&lt;absatz&gt;Hierbei ist zu beachten, dass die Meldungsnummer von der
				Erstmeldung einer Störung bis zur Löschung erhalten bleibt, also vom
				Inhalt mehr einer Vorgangsnummer entspricht.
			&lt;&#47;absatz&gt;
			&lt;absatz&gt;Steht die Verbindung zur LMS nicht zur Verfügung, werden die
				zu versendenden Meldungen solange zwischengespeichert, bis die
				RDS&#47;TMC-Meldung ungültig wird oder die Verbindung zur LMS wieder
				funktionsfähig ist und die RDS&#47;TMC-Meldung verschickt werden kann.
			&lt;&#47;absatz&gt;
			&lt;absatz&gt;Da ein großer Teil der Attribute einer Meldung optional ist, sind folgende Besonderheiten zu beachten:
			&lt;&#47;absatz&gt;
			&lt;liste zeichen="punkt"&gt;
				&lt;listenPunkt&gt;Optionale Zeitangaben sind als variable Liste der Länge 1 modelliert.&lt;&#47;listenPunkt&gt;
				&lt;listenPunkt&gt;Optionale Gleitkommawerte sind als 'att.tic3OptionalerDoubleWert' mit Zustand 'NichtVersorgt' modelliert.&lt;&#47;listenPunkt&gt;
				&lt;listenPunkt&gt;Optionale strukturierte Werte sind als variable Liste der Länge 1 modelliert.&lt;&#47;listenPunkt&gt;
			&lt;&#47;liste&gt;
</p>
* @author BitCtrl Systems GmbH, M2T
 * @version KB-Version 4
 */
package de.bsvrz.sys.funclib.bitctrl.modell.tmkexlmstic3;
