/*
 * Java-Modell des Datenkatalogs.
 * Copyright (C) 2016 BitCtrl Systems GmbH 
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weißenfelser Straße 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.sys.funclib.bitctrl.modell.tmvewsimulationglobal.konfigurationsdaten;

import java.util.*;

import com.bitctrl.beans.*;

import de.bsvrz.dav.daf.main.*;
import de.bsvrz.dav.daf.main.config.*;
import de.bsvrz.sys.funclib.bitctrl.modell.*;
import de.bsvrz.sys.funclib.bitctrl.modell.annotation.*;
import de.bsvrz.sys.funclib.bitctrl.modell.att.*;
import de.bsvrz.sys.funclib.bitctrl.modell.impl.*;

/**
Konfigurierende Eigenschaften einer Simulation.
<p>

</p>
* @author BitCtrl Systems GmbH, M2T
 * @version Gültig seit KB-Version 1
 */
public class KdSimulationsEigenschaften extends AbstractKonfigurationsDatensatz<KdSimulationsEigenschaften.Daten> {

		/**
		 * Die vorhandenen Aspekte des Datensatzes.
		 */
		public static class Aspekte extends de.bsvrz.sys.funclib.bitctrl.modell.metamodellglobal.objekte.impl.AspektImpl implements Aspekt {
	
			public static Aspekt[] values() {
				return new Aspekt[] {
					Aspekte.Eigenschaften,
				};
			}
	
			/**
			 * Wird für konfigurierende Attributgruppen verwendet. Über die entsprechende Attributgruppe werden die konkreten Eigenschaften eines Objekts festgelegt.	 
			 *
			 * <p>
			 * 
	         * </p>
			 */
			public static final Aspekt Eigenschaften = new Aspekte("Eigenschaften", "asp.eigenschaften");
			
			;
			
			private final String name;
			private final String pid;
	
			private Aspekte(final String name, final String pid) {
				this.name = name;
				this.pid = pid;
			}
	
			@Override
			public String getName() {
				if (getSystemObject() == null) {
					return name;
				}
				return super.getName();
			}
	
			@Override
			public String getPid() {
				if (getSystemObject() == null) {
					return pid;
				}
				return super.getPid();
			}
			
			@Override
			public Aspect getSystemObject() {
				return (Aspect) super.getSystemObject();
			}
	
			@Override
			public String toString() {
				if (getSystemObject() == null) {
					return name + " (" + pid + ")";
				}
				return super.toString();
			}
	
		}
	
	/**
	 * Kapselt die Daten des Datensatzes.
	 */
	public static class Daten extends AbstractDatum implements KonfigurationsDatum {
		
		/**
		 * Initialisiert das Datum.
		 * 
		 * @param datensatz
		 *            der Datensatz zu dem das Datum gehört.
		 * @param aspekt
		 *            der Aspekt für das Datum.
		 */
		public Daten(final Datensatz datensatz, final Aspekt aspekt) {
			super(datensatz, aspekt);
		}
		
		
			/*
			 * Beginn Propertiesabschnitt
			 */
		
				private de.bsvrz.sys.funclib.bitctrl.modell.systemmodellglobal.attribute.AttSimulationsVariante
				 _simulationsVariante
				;
				private 	de.bsvrz.sys.funclib.bitctrl.modell.tmvewsimulationglobal.objekte.SimulationsStrecke
				 _simulationsStreckenReferenz
				;
		
			/**
			Simulationsvariante der Simulation.
			<p>
			
			</p>
			
			@return der Wert von SimulationsVariante.
			*/
				public de.bsvrz.sys.funclib.bitctrl.modell.systemmodellglobal.attribute.AttSimulationsVariante
				 getSimulationsVariante() {
				return _simulationsVariante;
			}
		
			/**
			Simulationsvariante der Simulation.
			<p>
			
			</p>
			
			@param _simulationsVariante der neue Wert von SimulationsVariante.
			*/
			public void setSimulationsVariante(de.bsvrz.sys.funclib.bitctrl.modell.systemmodellglobal.attribute.AttSimulationsVariante
			 _simulationsVariante) {
				this._simulationsVariante = _simulationsVariante;
			}
		
			/**
			Attribut zur Referenzierung von Simulationsstrecken.
			<p>
			
			</p>
			
			@return der Wert von SimulationsStreckenReferenz.
			*/
				public 	de.bsvrz.sys.funclib.bitctrl.modell.tmvewsimulationglobal.objekte.SimulationsStrecke
				 getSimulationsStreckenReferenz() {
				return _simulationsStreckenReferenz;
			}
		
			/**
			Attribut zur Referenzierung von Simulationsstrecken.
			<p>
			
			</p>
			
			@param _simulationsStreckenReferenz der neue Wert von SimulationsStreckenReferenz.
			*/
			public void setSimulationsStreckenReferenz(	de.bsvrz.sys.funclib.bitctrl.modell.tmvewsimulationglobal.objekte.SimulationsStrecke
			 _simulationsStreckenReferenz) {
				this._simulationsStreckenReferenz = _simulationsStreckenReferenz;
			}
		
		
			/*
			 * Ende Propertiesabschnitt
			 */
		
			/*
			 * Beginn Abschnitt Konvertierung Datenverteiler <-> Modell
			 */
		
			public void bean2Atl(final Data datum, final ObjektFactory factory) {
					// GanzzahlAttributTyp
					if (getSimulationsVariante() != null) {
		                if (getSimulationsVariante().isZustand()) {
		                    datum.getUnscaledValue("SimulationsVariante").setText(getSimulationsVariante().toString());
		                } else {
							datum.
							getUnscaledValue
		                	("SimulationsVariante").set(getSimulationsVariante().getValue());
		                }
					}
					// ObjektReferenzAttributTyp
						final Object soSimulationsStreckenReferenz = getSimulationsStreckenReferenz();
						final SystemObject tmpSimulationsStreckenReferenz;
							if (soSimulationsStreckenReferenz instanceof SystemObject) {
								tmpSimulationsStreckenReferenz = (SystemObject)soSimulationsStreckenReferenz;
							} else if(soSimulationsStreckenReferenz instanceof SystemObjekt){
								tmpSimulationsStreckenReferenz = ((SystemObjekt)soSimulationsStreckenReferenz).getSystemObject();
							} else{
								tmpSimulationsStreckenReferenz = null;
							}
						datum.getReferenceValue("SimulationsStreckenReferenz").setSystemObject(tmpSimulationsStreckenReferenz);
			}
		
			public void atl2Bean(final Data daten, final ObjektFactory factory) {
					// GanzzahlAttributTyp
							setSimulationsVariante(new de.bsvrz.sys.funclib.bitctrl.modell.systemmodellglobal.attribute.AttSimulationsVariante
							(daten.
								getUnscaledValue
							("SimulationsVariante").
									shortValue
							()));
					// ObjektReferenzAttributTyp
						final long idSimulationsStreckenReferenz = daten.getReferenceValue("SimulationsStreckenReferenz").getId();
						final SystemObjekt tmpSimulationsStreckenReferenz;
						if (idSimulationsStreckenReferenz == 0) {
							tmpSimulationsStreckenReferenz = null;
						} else {
							final SystemObject soSimulationsStreckenReferenz = factory.getDav().getDataModel().getObject(idSimulationsStreckenReferenz);
							if (soSimulationsStreckenReferenz == null) {
									tmpSimulationsStreckenReferenz = new de.bsvrz.sys.funclib.bitctrl.modell.tmvewsimulationglobal.objekte.impl.SimulationsStreckeUngueltig(idSimulationsStreckenReferenz);
							} else {
								tmpSimulationsStreckenReferenz = factory.getModellobjekt(soSimulationsStreckenReferenz);
							}
						}
						setSimulationsStreckenReferenz((	de.bsvrz.sys.funclib.bitctrl.modell.tmvewsimulationglobal.objekte.SimulationsStrecke
						) tmpSimulationsStreckenReferenz);
			}
		
			/*
			 * Ende Abschnitt Konvertierung Datenverteiler <-> Modell
			 */
		
			
		@Override
		public Daten clone() {
			final Daten klon = new Daten(dGetDatensatz(), dGetAspekt());
	
							klon.setSimulationsVariante(getSimulationsVariante());
							klon.setSimulationsStreckenReferenz(getSimulationsStreckenReferenz());
			
	
			return klon;
		}

		@Override
		public String toString() {
			return BeanUtils.toString(this);
		}
	
	}
	
		/** Die PID der Attributgruppe im Datenverteiler. */
		public static final String PID = "atg.simulationsEigenschaften";

	/**
	 * Initialisiert den Konfigurationsdatensatz.
	 * 
	 * @param systemObjekt
	 *            das Systemobjekt zu dem der Datensatz gehört.
	 * @param objektFactory
	 *            die ObjektFabrik, die der Datensatz verwenden soll.
	 */
	public KdSimulationsEigenschaften(final SystemObjekt systemObjekt,
			final ObjektFactory objektFactory) {
		super(systemObjekt, objektFactory);
	}

	
		@Override
		public void init(final SystemObject systemObject,
				final ObjektFactory objektFactory) {
			super.init(systemObject, objektFactory);
			for (final Aspekt asp : Aspekte.values()) {
				((AbstractSystemObjekt) asp).init(objektFactory.getModellobjekt(asp.getPid()).getSystemObject(), objektFactory);
			}
		}
		
		@Override
		protected String doGetPid() {
			return PID;
		}
	
		public Collection<? extends Aspekt> getAspekte() {
			return Arrays.asList(Aspekte.values());
		}
	
		public Daten createDatum() {
			Daten datum = new Daten(this, null);
			// TODO Auslesen der Defaultwerte geht nicht,
			// weil der Datenverteiler für Attribute ohne Defaultwert initial ungültige Werte setzt!!
			// datum.atl2Bean(createSendeCache(), getObjektFactory());
			return datum;
		}
		 
	
}
